*#FILE_EXTENSION .pov
*# Interface GID-PovRay 1.0
*# To export meshes of triangles
*# written by Miguel Pasenau - February 2005
*if(nelem(Linear)==0 && nelem(Triangle)==0 && nelem(Quadrilateral)==0)
*MessageBox Error: Must create a mesh of lines, triangles or quadrilaterals.
*endif
*#*if(isquadratic)
*#*MessageBox Error: elements are Quadratic.
*#*endif
*if(nelem(Tetrahedra) || nelem(Hexahedra))
*WarningBox Warning: Only lines, trianglea and quadrilaterals are written in the PovRay file.
*endif
*realformat "%g"
*intformat "%d"
#include "colors"

*#definimos los colores de las layers
*set var ThereIsSomething=0
*loop layers
*set var Write=0
*set Layer *LayerName *elems
*Set elems(Triangle)
*loop elems OnlyInLayer
*set var Write=1
*set var ThereIsSomething=1
*break
*end elems
*if( Write)
*set var R = Operation(LayerColorRGB(1)/255.0)
*set var G = Operation(LayerColorRGB(2)/255.0)
*set var B = Operation(LayerColorRGB(3)/255.0)
// *tcl(regsub -all {([^a-z,A-Z,0-9])} *LayerName {_})
#declare color_*tcl(regsub -all {([^a-z,A-Z,0-9])} *LayerName {_}) = rgb < *R, *G, *B>;
*endif
*end layers

*set var xcenter = 0.0
*set var ycenter = 0.0
*set var zcenter = 0.0
*set var xmin = 10e38
*set var ymin = 10e38
*set var zmin = 10e38
*set var xmax = -10e38
*set var ymax = -10e38
*set var zmax = -10e38
*if( ThereIsSomething)
*loop nodes
*set var x = NodesCoord(1,real)
*set var y = NodesCoord(2,real)
*set var z = NodesCoord(3,real)
*set var xcenter=Operation(xcenter+x)
*set var ycenter=Operation(ycenter+y)
*set var zcenter=Operation(zcenter+z)
*if( x > xmax) 
*set var xmax = x 
*endif
*if( y > ymax) 
*set var ymax = y 
*endif
*if( z > zmax) 
*set var zmax = z 
*endif
*if( x < xmin) 
*set var xmin = x 
*endif
*if( y < ymin) 
*set var ymin = y 
*endif
*if( z < zmin) 
*set var zmin = z 
*endif
*end nodes
*endif
*set var xcenter=Operation(xcenter/npoin)
*set var ycenter=Operation(ycenter/npoin)
*set var zcenter=Operation(zcenter/npoin)
*set var dx=Operation(xmax-xmin)
*set var dy=Operation(ymax-ymin)
*set var dz=Operation(zmax-zmin)
*set var diag=Operation(sqrt(dx*dx+dy*dy+dz*dz))

*loop layers
*set var Write=0
*set Layer *LayerName *elems
*Set elems(Triangle)
*loop elems OnlyInLayer
*set var Write=1
*break
*end elems
*if( Write)
#declare layer_*tcl(regsub -all {([^a-z,A-Z,0-9])} *LayerName {_}) = mesh2 {
  vertex_vectors {
    *npoin,
*loop nodes
    < *NodesCoord(1,real), *NodesCoord(2,real), *NodesCoord(3,real)>,
*end nodes
  }

  face_indices {
*set var ntriang=0
*Set elems(Triangle)
*loop elems OnlyInLayer
*set var ntriang=Operation(ntriang+1)
*end elems
    *ntriang,
*Set elems(Triangle)
*loop elems OnlyInLayer
*#Dummy, pq se numeran de 0..npoin-1 en povray (tambien para los indices de los vertices del triangulo)
    < *Operation(ElemsConec(1)-1), *Operation(ElemsConec(2)-1), *Operation(ElemsConec(3)-1)>
*end elems
  }

  texture {
    pigment { color_*tcl(regsub -all {([^a-z,A-Z,0-9])} *LayerName {_})}
  }
}

*endif
*end layers
  
// Center = *xcenter, *ycenter, *zcenter 
// *xmin <-> *xmax
// *ymin <-> *ymax
// *zmin <-> *zmax
// box_size = *dx, *dy, *dz
// Diagonal *diag

*# let's drawn som axes
#declare axes = union {         
  sphere {
    < 0.0, 0.0, 0.0>, *Operation(0.01*diag)
    texture { 
      pigment { color Yellow}
    }
  }

  cone {
    < 0.0, 0.0, 0.0>, *Operation(0.01*diag), 
    < *Operation(diag*0.1), 0.0, 0.0>, 0.0 
    texture { 
      pigment { color Red}
    }
  }
  		
  cone {
    < 0.0, 0.0, 0.0>, *Operation(0.01*diag), 
    < 0.0, *Operation(diag*0.1), 0.0>, 0.0 
    texture { 
      pigment { color Green}
    }
  }
  		
  cone {
    < 0.0, 0.0, 0.0>, *Operation(0.01*diag), 
    < 0.0, 0.0, *Operation(diag*0.1)>, 0.0 
    texture { 
      pigment { color Cyan}
    }
  }
}

background { color White}

light_source {
  < 90.0, 90.0, 150.0>
  color White
}
   
*loop layers
*set var Write=0
*set Layer *LayerName *elems
*Set elems(Triangle)
*loop elems OnlyInLayer
*set var Write=1
*break
*end elems
*if( Write)
object { 
  layer_*tcl(regsub -all {([^a-z,A-Z,0-9])} *LayerName {_})
  translate < *Operation(-xcenter), *Operation(-ycenter), *Operation(-zcenter)> 
}
*endif
*end layers

*if( ThereIsSomething)
//object { axes translate < *Operation(-dx*0.9), *Operation(-dy*0.9), 0.0>}

camera {
  location < *Operation(0.5*diag), *Operation(0.5*diag), *Operation(1.0*diag)>
  look_at < 0.0, 0.0, 0.0>
  angle 45
}
*endif
